<?php

/**
 * WPML Compatibility.
 *
 * @since 5.0.0
 */
class Iconic_WooThumbs_Compat_WPML {
	/**
	 * Run.
	 */
	public static function run() {
		add_action( 'plugins_loaded', array( __CLASS__, 'init' ) );
	}

	/**
	 * Init.
	 */
	public static function init() {
		if ( ! class_exists( 'WPML' ) ) {
			return;
		}

		add_action( 'iconic_woothumbs_all_image_ids', array( __CLASS__, 'modify_image_ids' ), 10, 2 );
	}

	/**
	 * Modify image IDs.
	 *
	 * @param array $image_ids
	 * @param int   $product_id
	 *
	 * @return array
	 */
	public static function modify_image_ids( $image_ids, $product_id ) {
		return array_map( array( __CLASS__, 'get_translated_media_id' ), $image_ids );
	}

	/**
	 * Get translated media ID
	 *
	 * @param int $media_file_id
	 *
	 * @return bool|int
	 */
	public static function get_translated_media_id( $media_file_id ) {
		$media_file_id = apply_filters( 'wpml_object_id', $media_file_id, 'attachment', true );

		return $media_file_id;
	}
}
