<?php
/**
 * Helpers.
 *
 * @package iconic-woothumbs
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

/**
 * Iconic_WooThumbs_Helpers.
 *
 * @since 5.0.0
 */
class Iconic_WooThumbs_Helpers {
	/**
	 * Get the global aspect ratio.
	 *
	 * @see https://developer.mozilla.org/en-US/docs/Web/CSS/aspect-ratio#syntax
	 *
	 * @param string $size Image size: either `single` or `gallery_thumbnail`.
	 *
	 * @return string
	 */
	public static function get_global_aspect_ratio( $size = 'single' ) {
		$ratio = Iconic_WooThumbs_Images::get_image_crop( $size );
		$ratio = ( $ratio && is_array( $ratio ) && count( $ratio ) === 2 ) ? implode( ':', $ratio ) : '';

		return $ratio;
	}
}


